var Je = Object.defineProperty;
var Ke = (r, e, t) => e in r ? Je(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t;
var N = (r, e, t) => Ke(r, typeof e != "symbol" ? e + "" : e, t);
import { openBlock as se, createElementBlock as le, defineComponent as Qe, ref as te, reactive as Ae, shallowRef as Ve, watch as et, toRaw as tt, onMounted as Re, normalizeClass as $e, createElementVNode as H, normalizeStyle as nt, createCommentVNode as Ne, createVNode as rt, createTextVNode as at } from "vue";
const it = (r, e) => {
  const t = r.__vccOpts || r;
  for (const [n, a] of e)
    t[n] = a;
  return t;
}, ot = {}, st = { class: "cf-player__loader" };
function lt(r, e) {
  return se(), le("div", st);
}
const ct = /* @__PURE__ */ it(ot, [["render", lt]]);
/**
  postmate - A powerful, simple, promise-based postMessage library
  @version v1.6.0
  @link https://github.com/dollarshaveclub/postmate
  @author Jacob Kelley <jakie8@gmail.com>
  @license MIT
**/
var V = "application/x-postmate-v1+json", ut = 5, ft = 0, dt = function() {
  return ++ft;
}, E = function() {
  var e;
  return I.debug ? (e = console).log.apply(e, arguments) : null;
}, ht = function(e) {
  var t = document.createElement("a");
  t.href = e;
  var n = t.protocol.length > 4 ? t.protocol : window.location.protocol, a = t.host.length ? t.port === "80" || t.port === "443" ? t.hostname : t.host : window.location.host;
  return t.origin || n + "//" + a;
}, pt = {
  handshake: 1,
  "handshake-reply": 1,
  call: 1,
  emit: 1,
  reply: 1,
  request: 1
  /**
   * Ensures that a message is safe to interpret
   * @param  {Object} message The postmate message being sent
   * @param  {String|Boolean} allowedOrigin The whitelisted origin or false to skip origin check
   * @return {Boolean}
   */
}, Te = function(e, t) {
  return !(typeof t == "string" && e.origin !== t || !e.data || typeof e.data == "object" && !("postmate" in e.data) || e.data.type !== V || !pt[e.data.postmate]);
}, gt = function(e, t) {
  var n = typeof e[t] == "function" ? e[t]() : e[t];
  return I.Promise.resolve(n);
}, vt = /* @__PURE__ */ function() {
  function r(t) {
    var n = this;
    this.parent = t.parent, this.frame = t.frame, this.child = t.child, this.childOrigin = t.childOrigin, this.events = {}, process.env.NODE_ENV !== "production" && (E("Parent: Registering API"), E("Parent: Awaiting messages...")), this.listener = function(a) {
      if (!Te(a, n.childOrigin)) return !1;
      var o = ((a || {}).data || {}).value || {}, i = o.data, s = o.name;
      a.data.postmate === "emit" && (process.env.NODE_ENV !== "production" && E("Parent: Received event emission: " + s), s in n.events && n.events[s].forEach(function(c) {
        c.call(n, i);
      }));
    }, this.parent.addEventListener("message", this.listener, !1), process.env.NODE_ENV !== "production" && E("Parent: Awaiting event emissions from Child");
  }
  var e = r.prototype;
  return e.get = function(n) {
    var a = this;
    return new I.Promise(function(o) {
      var i = dt(), s = function c(p) {
        p.data.uid === i && p.data.postmate === "reply" && (a.parent.removeEventListener("message", c, !1), o(p.data.value));
      };
      a.parent.addEventListener("message", s, !1), a.child.postMessage({
        postmate: "request",
        type: V,
        property: n,
        uid: i
      }, a.childOrigin);
    });
  }, e.call = function(n, a) {
    this.child.postMessage({
      postmate: "call",
      type: V,
      property: n,
      data: a
    }, this.childOrigin);
  }, e.on = function(n, a) {
    this.events[n] || (this.events[n] = []), this.events[n].push(a);
  }, e.destroy = function() {
    process.env.NODE_ENV !== "production" && E("Parent: Destroying Postmate instance"), window.removeEventListener("message", this.listener, !1), this.frame.parentNode.removeChild(this.frame);
  }, r;
}(), mt = /* @__PURE__ */ function() {
  function r(t) {
    var n = this;
    this.model = t.model, this.parent = t.parent, this.parentOrigin = t.parentOrigin, this.child = t.child, process.env.NODE_ENV !== "production" && (E("Child: Registering API"), E("Child: Awaiting messages...")), this.child.addEventListener("message", function(a) {
      if (Te(a, n.parentOrigin)) {
        process.env.NODE_ENV !== "production" && E("Child: Received request", a.data);
        var o = a.data, i = o.property, s = o.uid, c = o.data;
        if (a.data.postmate === "call") {
          i in n.model && typeof n.model[i] == "function" && n.model[i](c);
          return;
        }
        gt(n.model, i).then(function(p) {
          return a.source.postMessage({
            property: i,
            postmate: "reply",
            type: V,
            uid: s,
            value: p
          }, a.origin);
        });
      }
    });
  }
  var e = r.prototype;
  return e.emit = function(n, a) {
    process.env.NODE_ENV !== "production" && E('Child: Emitting Event "' + n + '"', a), this.parent.postMessage({
      postmate: "emit",
      type: V,
      value: {
        name: n,
        data: a
      }
    }, this.parentOrigin);
  }, r;
}(), I = /* @__PURE__ */ function() {
  function r(t) {
    var n = t.container, a = n === void 0 ? typeof a < "u" ? a : document.body : n, o = t.model, i = t.url, s = t.name, c = t.classListArray, p = c === void 0 ? [] : c, y = t.frame;
    return this.parent = window, y ? this.frame = y : (this.frame = document.createElement("iframe"), this.frame.name = s || "", this.frame.classList.add.apply(this.frame.classList, p)), a.appendChild(this.frame), this.child = this.frame.contentWindow || this.frame.contentDocument.parentWindow, this.model = o || {}, this.sendHandshake(i);
  }
  var e = r.prototype;
  return e.sendHandshake = function(n) {
    var a = this, o = ht(n), i = 0, s;
    return new r.Promise(function(c, p) {
      var y = function A(_) {
        return Te(_, o) ? _.data.postmate === "handshake-reply" ? (clearInterval(s), process.env.NODE_ENV !== "production" && E("Parent: Received handshake reply from Child"), a.parent.removeEventListener("message", A, !1), a.childOrigin = _.origin, process.env.NODE_ENV !== "production" && E("Parent: Saving Child origin", a.childOrigin), c(new vt(a))) : (process.env.NODE_ENV !== "production" && E("Parent: Invalid handshake reply"), p("Failed handshake")) : !1;
      };
      a.parent.addEventListener("message", y, !1);
      var w = function() {
        i++, process.env.NODE_ENV !== "production" && E("Parent: Sending handshake attempt " + i, {
          childOrigin: o
        }), a.child.postMessage({
          postmate: "handshake",
          type: V,
          model: a.model
        }, o), i === ut && clearInterval(s);
      }, x = function() {
        w(), s = setInterval(w, 500);
      };
      a.frame.attachEvent ? a.frame.attachEvent("onload", x) : a.frame.addEventListener("load", x), process.env.NODE_ENV !== "production" && E("Parent: Loading frame", {
        url: n
      }), a.frame.src = n;
    });
  }, r;
}();
I.debug = !1;
I.Promise = function() {
  try {
    return window ? window.Promise : Promise;
  } catch {
    return null;
  }
}();
I.Model = /* @__PURE__ */ function() {
  function r(t) {
    return this.child = window, this.model = t, this.parent = this.child.parent, this.sendHandshakeReply();
  }
  var e = r.prototype;
  return e.sendHandshakeReply = function() {
    var n = this;
    return new I.Promise(function(a, o) {
      var i = function s(c) {
        if (c.data.postmate) {
          if (c.data.postmate === "handshake") {
            process.env.NODE_ENV !== "production" && E("Child: Received handshake from Parent"), n.child.removeEventListener("message", s, !1), process.env.NODE_ENV !== "production" && E("Child: Sending handshake reply to Parent"), c.source.postMessage({
              postmate: "handshake-reply",
              type: V
            }, c.origin), n.parentOrigin = c.origin;
            var p = c.data.model;
            return p && (Object.keys(p).forEach(function(y) {
              n.model[y] = p[y];
            }), process.env.NODE_ENV !== "production" && E("Child: Inherited and extended model from Parent")), process.env.NODE_ENV !== "production" && E("Child: Saving Parent origin", n.parentOrigin), a(new mt(n));
          }
          return o("Handshake Reply Failed");
        }
      };
      n.child.addEventListener("message", i, !1);
    });
  }, r;
}();
class Fe {
  constructor(e, t, n) {
    N(this, "emitter");
    N(this, "container");
    N(this, "options");
    this.emitter = e, this.container = t, this.options = n || {};
  }
  createFrame() {
    const e = document.createElement("iframe");
    return e.name = "cfp-iframe", e.setAttribute("style", "position:absolute;top:0;left:0;width:100%;height:100%;border:0"), e;
  }
}
class yt extends Fe {
  constructor() {
    super(...arguments);
    N(this, "parent");
  }
  async play(t, n) {
    return new Promise(async (a) => {
      const o = this.options.presentationAnimationEngineIframeUrl ? this.options.presentationAnimationEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/presentation-engine/index.html`, i = await new I({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: o,
        model: {
          playMetas: t.animation,
          defaultPage: n.defaultPage ? n.defaultPage : 1,
          defaultStep: n.defaultStep ? n.defaultStep : 1
        }
      });
      let s = !1;
      i.on("paginationChange", (c) => {
        this.emitter.emit("paginationChange", Object.assign(c, { total: t.page })), s || (s = !0, a());
      }), this.parent = i;
    });
  }
  async prev() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("prev");
  }
  async next() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("next");
  }
  async goto(t) {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    t.step = t.step ? t.step : 1, this.parent.call("goto", t);
  }
  async destroy() {
    this.parent && this.parent.destroy();
  }
}
const k = /* @__PURE__ */ new WeakMap(), L = /* @__PURE__ */ new WeakMap(), z = /* @__PURE__ */ new WeakMap(), ce = Symbol("anyProducer"), Be = Promise.resolve(), ue = Symbol("listenerAdded"), fe = Symbol("listenerRemoved");
let de = !1, _e = !1;
const he = (r) => typeof r == "string" || typeof r == "symbol" || typeof r == "number";
function B(r) {
  if (!he(r))
    throw new TypeError("`eventName` must be a string, symbol, or number");
}
function ne(r) {
  if (typeof r != "function")
    throw new TypeError("listener must be a function");
}
function X(r, e) {
  const t = L.get(r);
  if (t.has(e))
    return t.get(e);
}
function J(r, e) {
  const t = he(e) ? e : ce, n = z.get(r);
  if (n.has(t))
    return n.get(t);
}
function wt(r, e, t) {
  const n = z.get(r);
  if (n.has(e))
    for (const a of n.get(e))
      a.enqueue(t);
  if (n.has(ce)) {
    const a = Promise.all([e, t]);
    for (const o of n.get(ce))
      o.enqueue(a);
  }
}
function Xe(r, e) {
  e = Array.isArray(e) ? e : [e];
  let t = !1, n = () => {
  }, a = [];
  const o = {
    enqueue(i) {
      a.push(i), n();
    },
    finish() {
      t = !0, n();
    }
  };
  for (const i of e) {
    let s = J(r, i);
    s || (s = /* @__PURE__ */ new Set(), z.get(r).set(i, s)), s.add(o);
  }
  return {
    async next() {
      return a ? a.length === 0 ? t ? (a = void 0, this.next()) : (await new Promise((i) => {
        n = i;
      }), this.next()) : {
        done: !1,
        value: await a.shift()
      } : { done: !0 };
    },
    async return(i) {
      a = void 0;
      for (const s of e) {
        const c = J(r, s);
        c && (c.delete(o), c.size === 0 && z.get(r).delete(s));
      }
      return n(), arguments.length > 0 ? { done: !0, value: await i } : { done: !0 };
    },
    [Symbol.asyncIterator]() {
      return this;
    }
  };
}
function Ye(r) {
  if (r === void 0)
    return je;
  if (!Array.isArray(r))
    throw new TypeError("`methodNames` must be an array of strings");
  for (const e of r)
    if (!je.includes(e))
      throw typeof e != "string" ? new TypeError("`methodNames` element must be a string") : new Error(`${e} is not Emittery method`);
  return r;
}
const Y = (r) => r === ue || r === fe;
function re(r, e, t) {
  if (Y(e))
    try {
      de = !0, r.emit(e, t);
    } finally {
      de = !1;
    }
}
class R {
  static mixin(e, t) {
    return t = Ye(t), (n) => {
      if (typeof n != "function")
        throw new TypeError("`target` must be function");
      for (const i of t)
        if (n.prototype[i] !== void 0)
          throw new Error(`The property \`${i}\` already exists on \`target\``);
      function a() {
        return Object.defineProperty(this, e, {
          enumerable: !1,
          value: new R()
        }), this[e];
      }
      Object.defineProperty(n.prototype, e, {
        enumerable: !1,
        get: a
      });
      const o = (i) => function(...s) {
        return this[e][i](...s);
      };
      for (const i of t)
        Object.defineProperty(n.prototype, i, {
          enumerable: !1,
          value: o(i)
        });
      return n;
    };
  }
  static get isDebugEnabled() {
    var t;
    if (typeof ((t = globalThis.process) == null ? void 0 : t.env) != "object")
      return _e;
    const { env: e } = globalThis.process ?? { env: {} };
    return e.DEBUG === "emittery" || e.DEBUG === "*" || _e;
  }
  static set isDebugEnabled(e) {
    _e = e;
  }
  constructor(e = {}) {
    k.set(this, /* @__PURE__ */ new Set()), L.set(this, /* @__PURE__ */ new Map()), z.set(this, /* @__PURE__ */ new Map()), z.get(this).set(ce, /* @__PURE__ */ new Set()), this.debug = e.debug ?? {}, this.debug.enabled === void 0 && (this.debug.enabled = !1), this.debug.logger || (this.debug.logger = (t, n, a, o) => {
      try {
        o = JSON.stringify(o);
      } catch {
        o = `Object with the following keys failed to stringify: ${Object.keys(o).join(",")}`;
      }
      (typeof a == "symbol" || typeof a == "number") && (a = a.toString());
      const i = /* @__PURE__ */ new Date(), s = `${i.getHours()}:${i.getMinutes()}:${i.getSeconds()}.${i.getMilliseconds()}`;
      console.log(`[${s}][emittery:${t}][${n}] Event Name: ${a}
	data: ${o}`);
    });
  }
  logIfDebugEnabled(e, t, n) {
    (R.isDebugEnabled || this.debug.enabled) && this.debug.logger(e, this.debug.name, t, n);
  }
  on(e, t) {
    ne(t), e = Array.isArray(e) ? e : [e];
    for (const n of e) {
      B(n);
      let a = X(this, n);
      a || (a = /* @__PURE__ */ new Set(), L.get(this).set(n, a)), a.add(t), this.logIfDebugEnabled("subscribe", n, void 0), Y(n) || re(this, ue, { eventName: n, listener: t });
    }
    return this.off.bind(this, e, t);
  }
  off(e, t) {
    ne(t), e = Array.isArray(e) ? e : [e];
    for (const n of e) {
      B(n);
      const a = X(this, n);
      a && (a.delete(t), a.size === 0 && L.get(this).delete(n)), this.logIfDebugEnabled("unsubscribe", n, void 0), Y(n) || re(this, fe, { eventName: n, listener: t });
    }
  }
  once(e) {
    let t;
    const n = new Promise((a) => {
      t = this.on(e, (o) => {
        t(), a(o);
      });
    });
    return n.off = t, n;
  }
  events(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      B(t);
    return Xe(this, e);
  }
  async emit(e, t) {
    if (B(e), Y(e) && !de)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emit", e, t), wt(this, e, t);
    const n = X(this, e) ?? /* @__PURE__ */ new Set(), a = k.get(this), o = [...n], i = Y(e) ? [] : [...a];
    await Be, await Promise.all([
      ...o.map(async (s) => {
        if (n.has(s))
          return s(t);
      }),
      ...i.map(async (s) => {
        if (a.has(s))
          return s(e, t);
      })
    ]);
  }
  async emitSerial(e, t) {
    if (B(e), Y(e) && !de)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emitSerial", e, t);
    const n = X(this, e) ?? /* @__PURE__ */ new Set(), a = k.get(this), o = [...n], i = [...a];
    await Be;
    for (const s of o)
      n.has(s) && await s(t);
    for (const s of i)
      a.has(s) && await s(e, t);
  }
  onAny(e) {
    return ne(e), this.logIfDebugEnabled("subscribeAny", void 0, void 0), k.get(this).add(e), re(this, ue, { listener: e }), this.offAny.bind(this, e);
  }
  anyEvent() {
    return Xe(this);
  }
  offAny(e) {
    ne(e), this.logIfDebugEnabled("unsubscribeAny", void 0, void 0), re(this, fe, { listener: e }), k.get(this).delete(e);
  }
  clearListeners(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      if (this.logIfDebugEnabled("clear", t, void 0), he(t)) {
        const n = X(this, t);
        n && n.clear();
        const a = J(this, t);
        if (a) {
          for (const o of a)
            o.finish();
          a.clear();
        }
      } else {
        k.get(this).clear();
        for (const [n, a] of L.get(this).entries())
          a.clear(), L.get(this).delete(n);
        for (const [n, a] of z.get(this).entries()) {
          for (const o of a)
            o.finish();
          a.clear(), z.get(this).delete(n);
        }
      }
  }
  listenerCount(e) {
    var n, a, o;
    e = Array.isArray(e) ? e : [e];
    let t = 0;
    for (const i of e) {
      if (he(i)) {
        t += k.get(this).size + (((n = X(this, i)) == null ? void 0 : n.size) ?? 0) + (((a = J(this, i)) == null ? void 0 : a.size) ?? 0) + (((o = J(this)) == null ? void 0 : o.size) ?? 0);
        continue;
      }
      i !== void 0 && B(i), t += k.get(this).size;
      for (const s of L.get(this).values())
        t += s.size;
      for (const s of z.get(this).values())
        t += s.size;
    }
    return t;
  }
  bindMethods(e, t) {
    if (typeof e != "object" || e === null)
      throw new TypeError("`target` must be an object");
    t = Ye(t);
    for (const n of t) {
      if (e[n] !== void 0)
        throw new Error(`The property \`${n}\` already exists on \`target\``);
      Object.defineProperty(e, n, {
        enumerable: !1,
        value: this[n].bind(this)
      });
    }
  }
}
const je = Object.getOwnPropertyNames(R.prototype).filter((r) => r !== "constructor");
Object.defineProperty(R, "listenerAdded", {
  value: ue,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
Object.defineProperty(R, "listenerRemoved", {
  value: fe,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
class bt extends Fe {
  constructor() {
    super(...arguments);
    N(this, "postmate");
  }
  async play(t, n) {
    return new Promise(async (a) => {
      const o = this.options.imageEngineIframeUrl ? this.options.imageEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/image-engine/index.html`, i = await new I({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: o,
        model: {
          metas: t,
          defaultPage: n.defaultPage ? n.defaultPage : 1,
          vertical: n.vertical ? n.vertical : !1
        }
      });
      let s = !1;
      i.on("paginationChange", (c) => {
        console.warn("paginationChange"), this.emitter.emit("paginationChange", c), s || (s = !0, setTimeout(() => {
          console.warn("played"), a();
        }, 500));
      }), this.postmate = i;
    });
  }
  async prev() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("prev");
  }
  async next() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("next");
  }
  async goto(t) {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    this.postmate.call("goto", t);
  }
  async destroy() {
    this.postmate && this.postmate.destroy();
  }
}
var b = function() {
  return b = Object.assign || function(e) {
    for (var t, n = 1, a = arguments.length; n < a; n++) {
      t = arguments[n];
      for (var o in t) Object.prototype.hasOwnProperty.call(t, o) && (e[o] = t[o]);
    }
    return e;
  }, b.apply(this, arguments);
};
typeof window < "u" && (window.NodeList && !NodeList.prototype.forEach && (NodeList.prototype.forEach = Array.prototype.forEach), typeof window.CustomEvent != "function" && (window.CustomEvent = function(e, t) {
  t = t || { bubbles: !1, cancelable: !1, detail: null };
  var n = document.createEvent("CustomEvent");
  return n.initCustomEvent(e, t.bubbles, t.cancelable, t.detail), n;
}));
function Ge(r, e) {
  for (var t = r.length; t--; )
    if (r[t].pointerId === e.pointerId)
      return t;
  return -1;
}
function ke(r, e) {
  var t;
  if (e.touches) {
    t = 0;
    for (var n = 0, a = e.touches; n < a.length; n++) {
      var o = a[n];
      o.pointerId = t++, ke(r, o);
    }
    return;
  }
  t = Ge(r, e), t > -1 && r.splice(t, 1), r.push(e);
}
function Et(r, e) {
  if (e.touches) {
    for (; r.length; )
      r.pop();
    return;
  }
  var t = Ge(r, e);
  t > -1 && r.splice(t, 1);
}
function Ue(r) {
  r = r.slice(0);
  for (var e = r.pop(), t; t = r.pop(); )
    e = {
      clientX: (t.clientX - e.clientX) / 2 + e.clientX,
      clientY: (t.clientY - e.clientY) / 2 + e.clientY
    };
  return e;
}
function Me(r) {
  if (r.length < 2)
    return 0;
  var e = r[0], t = r[1];
  return Math.sqrt(Math.pow(Math.abs(t.clientX - e.clientX), 2) + Math.pow(Math.abs(t.clientY - e.clientY), 2));
}
var K = {
  down: "mousedown",
  move: "mousemove",
  up: "mouseup mouseleave"
};
typeof window < "u" && (typeof window.PointerEvent == "function" ? K = {
  down: "pointerdown",
  move: "pointermove",
  up: "pointerup pointerleave pointercancel"
} : typeof window.TouchEvent == "function" && (K = {
  down: "touchstart",
  move: "touchmove",
  up: "touchend touchcancel"
}));
function Se(r, e, t, n) {
  K[r].split(" ").forEach(function(a) {
    e.addEventListener(a, t, n);
  });
}
function Ce(r, e, t) {
  K[r].split(" ").forEach(function(n) {
    e.removeEventListener(n, t);
  });
}
var Pt = typeof document < "u" && !!document.documentMode, ze;
function xt() {
  return ze || (ze = document.createElement("div").style);
}
var qe = ["webkit", "moz", "ms"], ae = {};
function De(r) {
  if (ae[r])
    return ae[r];
  var e = xt();
  if (r in e)
    return ae[r] = r;
  for (var t = r[0].toUpperCase() + r.slice(1), n = qe.length; n--; ) {
    var a = "".concat(qe[n]).concat(t);
    if (a in e)
      return ae[r] = a;
  }
}
function ie(r, e) {
  return parseFloat(e[De(r)]) || 0;
}
function oe(r, e, t) {
  t === void 0 && (t = window.getComputedStyle(r));
  var n = e === "border" ? "Width" : "";
  return {
    left: ie("".concat(e, "Left").concat(n), t),
    right: ie("".concat(e, "Right").concat(n), t),
    top: ie("".concat(e, "Top").concat(n), t),
    bottom: ie("".concat(e, "Bottom").concat(n), t)
  };
}
function j(r, e, t) {
  r.style[De(e)] = t;
}
function Ot(r, e) {
  var t = De("transform");
  j(r, "transition", "".concat(t, " ").concat(e.duration, "ms ").concat(e.easing));
}
function At(r, e, t) {
  var n = e.x, a = e.y, o = e.scale, i = e.isSVG;
  if (j(r, "transform", "scale(".concat(o, ") translate(").concat(n, "px, ").concat(a, "px)")), i && Pt) {
    var s = window.getComputedStyle(r).getPropertyValue("transform");
    r.setAttribute("transform", s);
  }
}
function Ie(r) {
  var e = r.parentNode, t = window.getComputedStyle(r), n = window.getComputedStyle(e), a = r.getBoundingClientRect(), o = e.getBoundingClientRect();
  return {
    elem: {
      style: t,
      width: a.width,
      height: a.height,
      top: a.top,
      bottom: a.bottom,
      left: a.left,
      right: a.right,
      margin: oe(r, "margin", t),
      border: oe(r, "border", t)
    },
    parent: {
      style: n,
      width: o.width,
      height: o.height,
      top: o.top,
      bottom: o.bottom,
      left: o.left,
      right: o.right,
      padding: oe(e, "padding", n),
      border: oe(e, "border", n)
    }
  };
}
function _t(r) {
  var e = r.ownerDocument, t = r.parentNode;
  return e && t && e.nodeType === 9 && t.nodeType === 1 && e.documentElement.contains(t);
}
function Mt(r) {
  return (r.getAttribute("class") || "").trim();
}
function St(r, e) {
  return r.nodeType === 1 && " ".concat(Mt(r), " ").indexOf(" ".concat(e, " ")) > -1;
}
function Ct(r, e) {
  for (var t = r; t != null; t = t.parentNode)
    if (St(t, e.excludeClass) || e.exclude.indexOf(t) > -1)
      return !0;
  return !1;
}
var zt = /^http:[\w\.\/]+svg$/;
function It(r) {
  return zt.test(r.namespaceURI) && r.nodeName.toLowerCase() !== "svg";
}
function kt(r) {
  var e = {};
  for (var t in r)
    r.hasOwnProperty(t) && (e[t] = r[t]);
  return e;
}
var We = {
  animate: !1,
  canvas: !1,
  cursor: "move",
  disablePan: !1,
  disableZoom: !1,
  disableXAxis: !1,
  disableYAxis: !1,
  duration: 200,
  easing: "ease-in-out",
  exclude: [],
  excludeClass: "panzoom-exclude",
  handleStartEvent: function(r) {
    r.preventDefault(), r.stopPropagation();
  },
  maxScale: 4,
  minScale: 0.125,
  overflow: "hidden",
  panOnlyWhenZoomed: !1,
  pinchAndPan: !1,
  relative: !1,
  setTransform: At,
  startX: 0,
  startY: 0,
  startScale: 1,
  step: 0.3,
  touchAction: "none"
};
function Ze(r, e) {
  if (!r)
    throw new Error("Panzoom requires an element as an argument");
  if (r.nodeType !== 1)
    throw new Error("Panzoom requires an element with a nodeType of 1");
  if (!_t(r))
    throw new Error("Panzoom should be called on elements that have been attached to the DOM");
  e = b(b({}, We), e);
  var t = It(r), n = r.parentNode;
  n.style.overflow = e.overflow, n.style.userSelect = "none", n.style.touchAction = e.touchAction, (e.canvas ? n : r).style.cursor = e.cursor, r.style.userSelect = "none", r.style.touchAction = e.touchAction, j(r, "transformOrigin", typeof e.origin == "string" ? e.origin : t ? "0 0" : "50% 50%");
  function a() {
    n.style.overflow = "", n.style.userSelect = "", n.style.touchAction = "", n.style.cursor = "", r.style.cursor = "", r.style.userSelect = "", r.style.touchAction = "", j(r, "transformOrigin", "");
  }
  function o(l) {
    l === void 0 && (l = {});
    for (var f in l)
      l.hasOwnProperty(f) && (e[f] = l[f]);
    (l.hasOwnProperty("cursor") || l.hasOwnProperty("canvas")) && (n.style.cursor = r.style.cursor = "", (e.canvas ? n : r).style.cursor = e.cursor), l.hasOwnProperty("overflow") && (n.style.overflow = l.overflow), l.hasOwnProperty("touchAction") && (n.style.touchAction = l.touchAction, r.style.touchAction = l.touchAction);
  }
  var i = 0, s = 0, c = 1, p = !1;
  $(e.startScale, { animate: !1, force: !0 }), setTimeout(function() {
    _(e.startX, e.startY, { animate: !1, force: !0 });
  });
  function y(l, f, h) {
    if (!h.silent) {
      var v = new CustomEvent(l, { detail: f });
      r.dispatchEvent(v);
    }
  }
  function w(l, f, h) {
    var v = { x: i, y: s, scale: c, isSVG: t, originalEvent: h };
    return requestAnimationFrame(function() {
      typeof f.animate == "boolean" && (f.animate ? Ot(r, f) : j(r, "transition", "none")), f.setTransform(r, v, f), y(l, v, f), y("panzoomchange", v, f);
    }), v;
  }
  function x(l, f, h, v) {
    var u = b(b({}, e), v), g = { x: i, y: s, opts: u };
    if (!u.force && (u.disablePan || u.panOnlyWhenZoomed && c === u.startScale))
      return g;
    if (l = parseFloat(l), f = parseFloat(f), u.disableXAxis || (g.x = (u.relative ? i : 0) + l), u.disableYAxis || (g.y = (u.relative ? s : 0) + f), u.contain) {
      var d = Ie(r), O = d.elem.width / c, S = d.elem.height / c, W = O * h, Z = S * h, T = (W - O) / 2, D = (Z - S) / 2;
      if (u.contain === "inside") {
        var Ee = (-d.elem.margin.left - d.parent.padding.left + T) / h, Pe = (d.parent.width - W - d.parent.padding.left - d.elem.margin.left - d.parent.border.left - d.parent.border.right + T) / h;
        g.x = Math.max(Math.min(g.x, Pe), Ee);
        var xe = (-d.elem.margin.top - d.parent.padding.top + D) / h, Oe = (d.parent.height - Z - d.parent.padding.top - d.elem.margin.top - d.parent.border.top - d.parent.border.bottom + D) / h;
        g.y = Math.max(Math.min(g.y, Oe), xe);
      } else if (u.contain === "outside") {
        var Ee = (-(W - d.parent.width) - d.parent.padding.left - d.parent.border.left - d.parent.border.right + T) / h, Pe = (T - d.parent.padding.left) / h;
        g.x = Math.max(Math.min(g.x, Pe), Ee);
        var xe = (-(Z - d.parent.height) - d.parent.padding.top - d.parent.border.top - d.parent.border.bottom + D) / h, Oe = (D - d.parent.padding.top) / h;
        g.y = Math.max(Math.min(g.y, Oe), xe);
      }
    }
    return u.roundPixels && (g.x = Math.round(g.x), g.y = Math.round(g.y)), g;
  }
  function A(l, f) {
    var h = b(b({}, e), f), v = { scale: c, opts: h };
    if (!h.force && h.disableZoom)
      return v;
    var u = e.minScale, g = e.maxScale;
    if (h.contain) {
      var d = Ie(r), O = d.elem.width / c, S = d.elem.height / c;
      if (O > 1 && S > 1) {
        var W = d.parent.width - d.parent.border.left - d.parent.border.right, Z = d.parent.height - d.parent.border.top - d.parent.border.bottom, T = W / O, D = Z / S;
        e.contain === "inside" ? g = Math.min(g, T, D) : e.contain === "outside" && (u = Math.max(u, T, D));
      }
    }
    return v.scale = Math.min(Math.max(l, u), g), v;
  }
  function _(l, f, h, v) {
    var u = x(l, f, c, h);
    return i !== u.x || s !== u.y ? (i = u.x, s = u.y, w("panzoompan", u.opts, v)) : { x: i, y: s, scale: c, isSVG: t, originalEvent: v };
  }
  function $(l, f, h) {
    var v = A(l, f), u = v.opts;
    if (!(!u.force && u.disableZoom)) {
      l = v.scale;
      var g = i, d = s;
      if (u.focal) {
        var O = u.focal;
        g = (O.x / l - O.x / c + i * l) / l, d = (O.y / l - O.y / c + s * l) / l;
      }
      var S = x(g, d, l, { relative: !1, force: !0 });
      return i = S.x, s = S.y, c = l, w("panzoomzoom", u, h);
    }
  }
  function Q(l, f) {
    var h = b(b(b({}, e), { animate: !0 }), f);
    return $(c * Math.exp((l ? 1 : -1) * h.step), h);
  }
  function pe(l) {
    return Q(!0, l);
  }
  function ge(l) {
    return Q(!1, l);
  }
  function U(l, f, h, v) {
    var u = Ie(r), g = {
      width: u.parent.width - u.parent.padding.left - u.parent.padding.right - u.parent.border.left - u.parent.border.right,
      height: u.parent.height - u.parent.padding.top - u.parent.padding.bottom - u.parent.border.top - u.parent.border.bottom
    }, d = f.clientX - u.parent.left - u.parent.padding.left - u.parent.border.left - u.elem.margin.left, O = f.clientY - u.parent.top - u.parent.padding.top - u.parent.border.top - u.elem.margin.top;
    t || (d -= u.elem.width / c / 2, O -= u.elem.height / c / 2);
    var S = {
      x: d / g.width * (g.width * l),
      y: O / g.height * (g.height * l)
    };
    return $(l, b(b({}, h), { animate: !1, focal: S }), v);
  }
  function ve(l, f) {
    l.preventDefault();
    var h = b(b(b({}, e), f), { animate: !1 }), v = l.deltaY === 0 && l.deltaX ? l.deltaX : l.deltaY, u = v < 0 ? 1 : -1, g = A(c * Math.exp(u * h.step / 3), h).scale;
    return U(g, l, h, l);
  }
  function C(l) {
    var f = b(b(b({}, e), { animate: !0, force: !0 }), l);
    c = A(f.startScale, f).scale;
    var h = x(f.startX, f.startY, c, f);
    return i = h.x, s = h.y, w("panzoomreset", f);
  }
  var q, F, G, m, P, ee, M = [];
  function me(l) {
    if (!Ct(l.target, e)) {
      ke(M, l), p = !0, e.handleStartEvent(l), q = i, F = s, y("panzoomstart", { x: i, y: s, scale: c, isSVG: t, originalEvent: l }, e);
      var f = Ue(M);
      G = f.clientX, m = f.clientY, P = c, ee = Me(M);
    }
  }
  function ye(l) {
    if (!(!p || q === void 0 || F === void 0 || G === void 0 || m === void 0)) {
      ke(M, l);
      var f = Ue(M), h = M.length > 1, v = c;
      if (h) {
        ee === 0 && (ee = Me(M));
        var u = Me(M) - ee;
        v = A(u * e.step / 80 + P).scale, U(v, f, { animate: !1 }, l);
      }
      (!h || e.pinchAndPan) && _(q + (f.clientX - G) / v, F + (f.clientY - m) / v, {
        animate: !1
      }, l);
    }
  }
  function we(l) {
    M.length === 1 && y("panzoomend", { x: i, y: s, scale: c, isSVG: t, originalEvent: l }, e), Et(M, l), p && (p = !1, q = F = G = m = void 0);
  }
  var be = !1;
  function Le() {
    be || (be = !0, Se("down", e.canvas ? n : r, me), Se("move", document, ye, { passive: !0 }), Se("up", document, we, { passive: !0 }));
  }
  function He() {
    be = !1, Ce("down", e.canvas ? n : r, me), Ce("move", document, ye), Ce("up", document, we);
  }
  return e.noBind || Le(), {
    bind: Le,
    destroy: He,
    eventNames: K,
    getPan: function() {
      return { x: i, y: s };
    },
    getScale: function() {
      return c;
    },
    getOptions: function() {
      return kt(e);
    },
    handleDown: me,
    handleMove: ye,
    handleUp: we,
    pan: _,
    reset: C,
    resetStyle: a,
    setOptions: o,
    setStyle: function(l, f) {
      return j(r, l, f);
    },
    zoom: $,
    zoomIn: pe,
    zoomOut: ge,
    zoomToPoint: U,
    zoomWithWheel: ve
  };
}
Ze.defaultOptions = We;
const Tt = {
  key: 0,
  ref: "boardEl",
  class: "cf-player__board"
}, Dt = {
  key: 1,
  class: "cf-player__mask"
}, Rt = /* @__PURE__ */ Qe({
  __name: "Player",
  props: {
    file: {},
    engine: { default: "image" },
    defaultPage: { default: 1 },
    defaultStep: { default: 1 },
    vertical: { type: Boolean, default: !1 },
    dark: { type: Boolean, default: !1 },
    enableBoard: { type: Boolean, default: !1 },
    enableZoom: { type: Boolean, default: !1 },
    engineBaseUrl: {},
    imageEngineIframeUrl: {},
    presentationAnimationEngineIframeUrl: {}
  },
  emits: ["paginationChange"],
  setup(r, { expose: e, emit: t }) {
    const n = r, a = t, o = te(null), i = te(null), s = te(null), c = Ae({}), p = Ae({
      width: 0,
      height: 0
    }), y = Ae({
      width: 0,
      height: 0
    }), w = Ve(null), x = Ve(null), A = new R();
    A.on("paginationChange", (m) => {
      a("paginationChange", m);
    });
    const _ = te(!1);
    et([() => n.file, () => n.engine], async () => {
      if (n.file) {
        if (typeof n.file == "string")
          throw new Error("File id is not supported, but coming soon...");
        x.value = n.file, x.value && (_.value = !0, await U(x.value, n.engine), await w.value.play(tt(x.value), {
          defaultPage: n.defaultPage,
          defaultStep: n.defaultStep,
          vertical: n.vertical
        }), _.value = !1);
      }
    }, { immediate: !0 });
    const $ = async () => {
      if (!w.value)
        throw new Error("No engine.");
      await w.value.prev();
    }, Q = async () => {
      if (!w.value)
        throw new Error("No engine.");
      await w.value.next();
    }, pe = async (m) => {
      if (!w.value)
        throw new Error("No engine.");
      await w.value.goto(m);
    }, ge = () => {
      if (!x.value || !x.value.page || !x.value.thumb)
        return [];
      const m = [];
      for (let P = 1; P <= x.value.page; P++)
        m.push({ page: P, url: x.value.thumb + P });
      return m;
    }, U = async (m, P) => {
      if (await ve(), m.type === "Presentation")
        P === "image" ? w.value = new bt(A, s.value, n) : P === "presentation" && (w.value = new yt(A, s.value, n));
      else throw m.type === "Word" ? new Error("Coming soon.") : m.type === "PDF" ? new Error("Coming soon.") : new Error("Not support file type.");
    }, ve = async () => {
      w.value && (await w.value.destroy(), w.value = null);
    };
    Re(() => {
      const m = 1.7777777777777777;
      p.width = o.value.clientWidth, p.height = o.value.clientHeight, console.log("[cf-player] player width", p.width), console.log("[cf-player] player height", p.height), p.width / p.height > m ? (y.width = Math.round(p.height * m), y.height = p.height, c.width = `${y.width}px`, c.height = `${p.height}px`, c.top = "0", c.left = `${Math.round((p.width - y.width) / 2)}px`) : (y.width = p.width, y.height = Math.round(p.width * (1 / m)), c.width = `${p.width}px`, c.height = `${y.height}px`, c.top = `${Math.round(p.height - y.height) / 2}px`, c.left = "0");
    });
    let C;
    return Re(() => {
      n.enableZoom && (C = Ze(i.value, {
        maxScale: 3,
        minScale: 0.4,
        origin: "50% 0%",
        animate: !1,
        // what ?
        handleStartEvent: () => {
        }
      }));
    }), e({
      prev: $,
      next: Q,
      goto: pe,
      thumbs: ge,
      zoomIn: () => {
        !n.enableZoom || !C || C.zoomIn();
      },
      zoomOut: () => {
        !n.enableZoom || !C || C.zoomOut();
      },
      zoomReset: () => {
        !n.enableZoom || !C || C.reset();
      }
    }), (m, P) => (se(), le("div", {
      ref_key: "playerEl",
      ref: o,
      class: $e(["cf-player", { "cf-player--dark": m.dark }])
    }, [
      H("div", {
        class: "cf-player__viewport",
        style: nt(c)
      }, [
        H("div", {
          ref_key: "layersEl",
          ref: i,
          class: "cf-player__layers"
        }, [
          H("div", {
            ref_key: "contentEl",
            ref: s,
            class: $e(["cf-player__content", [m.vertical ? "cf-player__content--vertical" : "cf-player__content--horizontal"]])
          }, null, 2),
          P[2] || (P[2] = H("div", { class: "cf-player__ground" }, null, -1)),
          m.enableBoard ? (se(), le("div", Tt, null, 512)) : Ne("", !0),
          _.value ? (se(), le("div", Dt, [
            rt(ct),
            P[0] || (P[0] = at()),
            P[1] || (P[1] = H("span", { class: "cf-player__mask__text" }, "文件加载中...", -1))
          ])) : Ne("", !0)
        ], 512)
      ], 4)
    ], 2));
  }
});
export {
  Rt as CloudFilePlayer
};
